package iHMMuneAlign;

import java.io.*;
import java.util.ArrayList;
import org.biojava.bio.BioException;
import org.biojava.bio.seq.Sequence;
import org.biojava.bio.seq.SequenceIterator;
import org.biojava.bio.seq.io.SeqIOTools;

public class FastaReader
{

    public FastaReader()
    {
    }

    public static void main(String args[])
    {
        FastaReader fastaReader = new FastaReader();
        try
        {
            ArrayList dGenes = fastaReader.readFile(new File("d-regions.fa"));
            int totalLength = 0;
            int numberOfDGenes = dGenes.size();
            for(int i = 0; i < numberOfDGenes; i++)
            {
                Sequence currGene = (Sequence)dGenes.get(i);
                totalLength += currGene.length();
            }

            double averageLength = (double)totalLength / (double)numberOfDGenes;
            System.out.println("average D-Gene length = " + averageLength);
        }
        catch(Exception ex)
        {
            throw new Error(ex.getMessage());
        }
    }

    public ArrayList readFile(File file)
    {
        ArrayList sequences = new ArrayList();
        BufferedReader br = null;
        try
        {
            br = new BufferedReader(new FileReader(file));
        }
        catch(FileNotFoundException fnfe)
        {
            System.out.println("The specified file was not found");
            return null;
        }
        SequenceIterator stream = SeqIOTools.readFastaDNA(br);
        int counter = 0;
        Sequence seq = null;
        while(stream.hasNext()) 
        {
            try
            {
                seq = stream.nextSequence();
            }
            catch(BioException bioe)
            {
                System.out.println("Bio Exception when attempting to read from fasta file");
                return null;
            }
            sequences.add(seq);
            counter++;
        }
        return sequences;
    }
}
